<?php
//YANMAH2 - Yet ANother Mobile Accelerated HatenaHaiku
//(c) 2012 YANMAH2 project
//This program is freesoftware. you can redistribute it and/or modify it under the terms of the [GNU Affero GPL v3](http://www.gnu.org/licenses/agpl.html).
?>
<?php
define("HELLO","world");
require_once "product_definitions.php";
require_once "configurable_variables.php";
require_once "common_functions.php";
?>
<?php
require_once 'init_processor.php';
// var_dump($_SESSION);
if (isset($_GET["reftime"]) && $_GET["reftime"] != '') {
  header('Cache-Control: private, max-age=' . 60*60*24);
}
?>
<?php
$selfcall = htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES);
$safequery = htmlspecialchars($_SERVER["QUERY_STRING"], ENT_QUOTES);
?>
<?php //セキュリティのための前処理。
//長すぎる keyword
if (isset($_GET["keyword"])) checkKeyword($_GET["keyword"]);
if (isset($_GET['word'])) checkKeyword($_GET['word']);
if (isset($_GET['users'])) checkKeyword($_GET['users']);
if (isset($_GET["user"])) {
  checkId($_GET["user"]);
  $_GET['user'] = preg_replace("/ +$/u", "", $_GET['user']);
  }
if (isset($_GET["following"])) {
  checkId($_GET["following"]);
  $_GET['following'] = preg_replace("/ +$/u", "", $_GET['following']);
}
//不正な page
if (isset($_GET['page'])) checkPagenum($_GET['page']);
if (isset($_GET['image'])) checkImagemode($_GET['image']);
if (isset($_SESSION['image'])) checkImagemode($_SESSION['image']);
if (isset($_GET['album'])) checkAlbum($_GET['album']);
?>
<?php
if (!isset($_SESSION['auth']) || $_SESSION['auth'] != TRUE){
// if ($_SESSION['image'] != 'on'){
  $_SESSION = array();
  if (isset($_COOKIE[session_name()])){
	setcookie(session_name(), '', time() - 42000, dirname($_SERVER['SCRIPT_NAME']) . '/', $_SERVER["SERVER_NAME"]);
  }
  session_destroy();
// }
}
?>
<?php
//
if (isset($_GET['with']) || isset($_GET['log'])){
  require 'login_processor.php';
}// if (isset($_SESSION['oauth_stat'])) session_regenerate_id(TRUE);

//投稿処理の呼び出し。
//var_dump($_POST);
if (isset($_POST['posting'])){
// if (isset($_SESSION['postkey']) && isset($_POST['postkey']) && md5($_SESSION['postkey']) == $_POST['postkey']){
//   unset($_SESSION['postkey']);
/*var_dump($_POST);
exit();*/
  require 'post_processor.php';
// }
}
?>
<?php
//前置きはこのくらいにして、本題に入る！
if (isset($_GET["keyword"]) && $_GET["keyword"] != ''){
	$get_keyword = htmlspecialchars($_GET["keyword"], ENT_QUOTES);
	$json_url = "{$api_base_url}statuses/keyword_timeline.xml?word=" . rawurlencode($_GET['keyword']) . "&body_formats=html_touch";
	$page_head = $get_keyword . " でひとこと";
	$official = "{$haiku_official_url}keyword/" . rawurlencode($_GET['keyword']);
	$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?keyword=" . rawurlencode($_GET['keyword']);
	$entries_mode = 'keyword_timeline';
}	elseif (isset($_GET["user"]) && $_GET["user"] != ''){
		$get_user = htmlspecialchars($_GET["user"], ENT_QUOTES);
		$json_url = "{$api_base_url}statuses/user_timeline/".$_GET['user'].".xml?body_formats=html_touch";
		$page_head = "{$get_user} のエントリー";
		$official = "{$haiku_official_url}{$get_user}/";
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?user=".rawurlencode($_GET['user']);
		$entries_mode = 'user_timeline';
}	elseif (isset($_GET["following"]) && $_GET["following"] != ''){
		$get_following = htmlspecialchars($_GET["following"], ENT_QUOTES);
		$json_url = "{$api_base_url}statuses/friends_timeline/".$_GET['following'].".xml";
		if (isset($_SESSION['auth']) && $_SESSION['auth'] === TRUE
		    && $get_following == $_SESSION['hatenaid']){
		    $json_url_noaouth = $json_url . "?body_formats=html_touch";
		    $json_url = "{$api_base_url}statuses/friends_timeline.xml";
		}
		$json_url = $json_url . "?body_formats=html_touch";
		$page_head = "{$get_following} のアンテナ";
		$official = "{$haiku_official_url}{$get_following}/following";
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?following=".rawurlencode($_GET['following']);
		$entries_mode = 'friends_timeline';
}	elseif (isset($_GET['album']) && $_GET['album'] != ''){
	if ($_GET['album'] == 'public'){
		$get_album = 'public';
		$json_url = "{$api_base_url}statuses/album.xml?body_formats=html_touch";
		$page_head = 'みんなのアルバム';
		$official = $haiku_official_url . 'album';
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?album=".rawurlencode($_GET['album']);
		$entries_mode = 'album';
	} else {
		$get_album = htmlspecialchars($_GET['album'], ENT_QUOTES);
		$json_url = "{$api_base_url}statuses/album.xml?word=".rawurlencode($_GET['album'])."&body_formats=html_touch";
		$page_head = $get_album.'のアルバム';
		$official = $haiku_official_url.'keyword/'.rawurlencode($_GET['keyword']).'?mode=album';
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?album=public";
		$entries_mode = 'album';
	}
}	elseif (isset($_GET['users']) && $_GET['users'] != ''){
	  if ($_GET['users'] == 'public'){
		$get_users = htmlspecialchars($_GET['users'], ENT_QUOTES);
		$json_url = $api_base_url.'statuses/public_timeline.xml?count=100&body_formats=html_touch';
		$page_head = 'ユーザー一覧';
		$official = $haiku_official_url;
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?users=public";
		$entries_mode = 'users';
	  } else {
		$get_users = htmlspecialchars($_GET['users'], ENT_QUOTES);
		$json_url = $api_base_url.'statuses/keyword_timeline.xml?word='.rawurlencode($_GET['users']).'&count=100&body_formats=html_touch';
		$page_head = $get_users.' のユーザー一覧';
		$official = "{$haiku_official_url}keyword/" . rawurlencode($_GET['users']);
		$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?users=".rawurlencode($_GET['users']);
		$entries_mode = 'keyword_users';
	  }
}	elseif (isset($_GET['favours']) && $_GET['favours'] != ''){
		$get_favours = htmlspecialchars($_GET['favours'], ENT_QUOTES);
		$json_url = "{$api_base_url}statuses/friends_timeline/".$get_favours.".xml";
		if (isset($_SESSION['auth']) && $_SESSION['auth'] === TRUE
		    && $get_favours == $_SESSION['hatenaid']){
		    $json_url_noaouth = $json_url . "?count=100&body_formats=html_touch";
		    $json_url = "{$api_base_url}statuses/friends_timeline.xml";
		}
		$json_url = $json_url . "?count=100&body_formats=html_touch";
	$page_head = $get_favours.' のお気に入り';
	$official = "{$haiku_official_url}following";
	$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?favours={$_GET['favours']}";
	$entries_mode = 'favours';
}	else {
	$json_url = "{$api_base_url}statuses/public_timeline.xml?body_formats=html_touch";
	$page_head = "みんなのエントリー";
	$official = $haiku_official_url;
	$self_anchor = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}";
	$entries_mode = 'default';
}
//
if (isset($_GET['page']) && $_GET['page'] != ''){
	if ($entries_mode == 'default'){
		$self_anchor_possibly_with_pagenum = $self_anchor . '?page=' . $_GET['page'];
	} else {
		$self_anchor_possibly_with_pagenum = $self_anchor . '&page=' . $_GET['page'];
	}
	$relog_back = $self_anchor_possibly_with_pagenum . '&log=try';
	$relogin = $self_anchor_possibly_with_pagenum . '&with=haiku&callback='.rawurlencode(rawurldecode($relog_back));
} else {
	if ($entries_mode != 'default'){
	  $self_anchor_possibly_with_pagenum = $self_anchor.'&page=1';
	} else {
	  $self_anchor_possibly_with_pagenum = $self_anchor.'?page=1';
	}
	  $relog_back = $self_anchor_possibly_with_pagenum . '&log=try';
	  $relogin = $self_anchor_possibly_with_pagenum . '&with=haiku&callback='.rawurlencode(rawurldecode($relog_back));
}
//
if ($get_image == 'on'){
		$self_anchor_with_imagemode = $self_anchor_possibly_with_pagenum . '&image=on';
} else {
		$self_anchor_with_imagemode = $self_anchor_possibly_with_pagenum . '&image=off';
}
$relog_back = $self_anchor_with_imagemode . '&log=try';
$relogin = $self_anchor_with_imagemode . '&amp;with=haiku&amp;callback='.rawurlencode(rawurldecode($relog_back));
?>
<?php
$echo = <<<EOL
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset={$meta_charset}" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta http-equiv="Content-Script-Type" content="text/javascript" />
	<meta name="viewport" content="initial-scale={$iscale}, minimum-scale=0.1" />
	<title>{$page_head} - {$site_name} {$site_name_caption}</title>
	<link rel="stylesheet" href="{$style_sheet}" />
	<link rel="icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />
	<link rel="shortcut icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />

EOL;
if (isset($starisjs) && $starisjs == '1'){
if ($entries_mode != 'users' && $entries_mode != 'keyword_users' && $entries_mode != 'favours'){
  $echo = $echo . <<<EOL
	<script type="text/javascript" src="http://s.hatena.ne.jp/js/HatenaStar.js"></script>
	<script type="text/javascript">
	Hatena.Star.SiteConfig = {
	  entryNodes: {
		'div.entry': {
		  uri: 'a.to-original-link',
		  title: 'a.keyword',
		  container: 'span.entry-head'
		}
	  }
	};
	</script>

EOL;
}
}
$echo = $echo . <<<EOL
</head>
<body>
<div id="page">
EOL;
?>
<?php
// var_dump($_SESSION);
//var_dump($_POST);
//var_dump($_GET);
$echo = $echo . echoCommonHeader('#navigation-menu', $self_anchor_with_imagemode) . "<hr />\n";
$echo = $echo . "<div id=\"header\" class=\"{$entries_mode}\">\n";
$echo = $echo . "<h1 id=\"entries-head\" class=\"head1\">{$page_head} <a href=\"{$official}\" class=\"to-original-link\">&nbsp;‡&nbsp;</a></h1>\n<hr />";
$echo = $echo . "</div>\n";
echo mb_convert_encoding($echo, $charcode, 'UTF-8');
$echo = '';
?>
<?php
if (isset($_SESSION['auth']) && $_SESSION['auth'] === TRUE){
  if ($device_who == 'ktai'){
	$rows = '3';
  } else {
	$rows = '6';
  }
	$echo = $echo . '<div class="post-box">';
	$echo = $echo . '<form method="post" action="./post.php" enctype="application/x-www-form-urlencoded" accept-charset="'.$meta_charset.'">';
	if ($entries_mode == 'keyword_timeline'){
		$echo = $echo . '<input type="hidden" id="post-keyword" name="keyword" value="' . $get_keyword . '" />';
	} else {
		$echo = $echo . '<input type="text" id="post-keyword" name="keyword" maxlength="255" value="';
		if (isset($_GET['word'])) $echo = $echo . htmlspecialchars($_GET['word'],ENT_QUOTES);
		$echo = $echo . '" title="キーワード" size="80" /><br />';
	}
	$echo = $echo . '<textarea id="post-text" name="status" rows="'. $rows .'" cols="80" title="本文">';
	if (isset($_GET['body'])) $echo = $echo . htmlspecialchars($_GET['body']);
	$echo = $echo . '</textarea><br />';
	$echo = $echo . '<input type="hidden" name="posting" value="status" />';
	$echo = $echo . '<input type="hidden" name="return" value="'.htmlspecialchars($self_anchor_possibly_with_pagenum,ENT_QUOTES).'" />';
/*  $rand = mt_rand(); $_SESSION['postkey'] = $rand;
  $rand_md5 = md5($rand);
  echo "<input type=\"hidden\" name=\"postkey\" value=\"{$rand_md5}\" />";*/
  if (isset($_GET['from']) && $_GET['from'] != ''){
	$_SESSION['source'] = htmlspecialchars($_GET['from'], ENT_QUOTES);
  }
  if (isset($_SESSION['source']) && $_SESSION['source'] != ''){
	$from = $_SESSION['source'];
  } else {
	$from = $product_name_abbr;
  }
  $echo = $echo . <<<EOL
<input type="submit" id="post-haiku" value="Haiku!" />
 <label for="post-from">from </label><input type="text" id="post-from" name="source" value="{$from}" maxlength="170" />
 <a href="./coco.php?
EOL;
// if (isset($_GET['keyword'])) echo '?keyword='.rawurlencode($_GET['keyword']);
$echo = $echo . "return=".htmlspecialchars($self_anchor_with_imagemode,ENT_QUOTES);
$echo = $echo . '" class="navigation-link">イマココ</a>';
$echo = $echo . '</form>';
 if (isset($_SESSION['post_result']) && $_SESSION['post_result'] != ''){
  $echo = $echo . '<div class="post-result">';
//   var_dump($_SESSION);
	if ($_SESSION['post_result'] === TRUE){
// 		var_dump($_SESSION['post_to']);
		if ($_SESSION['post_to'] == 'hateb'){
// 		  var_dump($_SESSION['post_body']);
		  $echo = $echo . echoHateBxml(simplexml_load_string($_SESSION['post_body']));
		} else {
		  $json_body = $_SESSION['post_body'];
		  $contents = checkEntryData($json_body);
		  if (preg_match("/^oauth_problem=token_rejected$/", $json_body)){
		      $echo = $echo . "<p>アクセストークンが無効になっています。<a href=\"{$relogin}\">再認証</a>を行なってください。</p>";
		  } elseif ($contents['stat'] == FALSE && $contents['ercode'] != 'x'){
			$echo = $echo . "<p>何かのエラーです。</p>\n";
			$echo = $echo . print_r(strip_tags($contents['contents']));
			$echo = $echo . "<br />{$json_body}</blockquote>\n";
		  } elseif ($contents['stat'] == FALSE && $contents['ercode'] == 'x'){
			$echo = $echo . "<p>何かのエラーですす。</p>\n";
			$echo = $echo . "<blockquote>{$contents['ermes']}</blockquote>\n";	
		  } else {
			$echo = $echo . '<span>' . $_SESSION['post_result_mes'] . '</span>';
			$entry_processor_mode = "entry"; $eprocessor_sub_mode = 'presult';
			$val = $contents['contents'];
			require 'entry_processor.php';
			unset($eprocessor_sub_mode);
			$echo = $echo . "<hr />\n";
/*		  $val = $_SESSION['post_body'];
		  require 'entry_processor.php';*/
		  }
		  $contents = '';
		}
	}
	if ($_SESSION['post_result'] === FALSE){
		$echo = $echo . '<span>' . $_SESSION['post_result_mes'] . '</span>';
		$echo = $echo . "<blockquote>{$_SESSION['post_error']}</blockquote>";
// 		var_export($_SESSION['$post_session']);
	}
  $echo = $echo . '</div>';
	$_SESSION['post_to'] = '';
	$_SESSION['post_result'] = '';
	$_SESSION['post_result_mes'] = '';
	$_SESSION['post_error'] = '';
	$_SESSION['post_body'] = '';
	libxml_clear_errors();
 }
$echo = $echo . '</div>';
echo mb_convert_encoding($echo, $charcode, 'UTF-8');
$echo = '';
}
if (isset($_SESSION['oauth_stat'])){
  $echo = $echo . '<div class="oauth-res">'."\n";
  if ($_SESSION['oauth_stat'] === TRUE) {
	$echo = $echo . "<span>アクセストークンを更新しました。</span>\n";
  } else {
	$echo = $echo . "<span>アクセストークンを取得できませんでした。</span>\n";
	$echo = $echo . "<blockquote>{$_SESSION['oauth_stat']}</blockquote>";
  }
  $echo = $echo . '</div>'."\n";
echo mb_convert_encoding($echo, $charcode, 'UTF-8');
$echo = '';
}
?>

<?php
$echo = $echo . '<div class="contents">'."\n";
function constRequest($json_url){
  global $ecount, $entries_mode;
  if (isset($_GET["reftime"]) && $_GET["reftime"] != '') {
	$request_url = $json_url . '&reftime=' . rawurlencode($_GET['reftime']);
  } elseif (!isset($_GET["page"])){
	  $request_url = $json_url;
  }	else {
	  $request_url = $json_url.'&page='.$_GET["page"];
  }
  if (isset($ecount) && !preg_match("/users|keyword_users|favours/", $entries_mode)){
	$request_url = $request_url . '&count=' . $ecount;
  }
  return $request_url;
}
$request_url = constRequest($json_url);
// var_dump($entries_mode);
// var_dump($request_url);
// var_dump($request_url);
// var_dump ($_GET);
// var_dump($get_image);
if (isset($_SESSION['auth']) && $_SESSION['auth'] === TRUE){
  $json = getJson($request_url, TRUE, $conkey, $conkey_sec, $_SESSION['acstoken'], $_SESSION['acs_sec']);
} else {
  $json = getJson($request_url, FALSE);
}
if (preg_match("/^oauth_problem=token_rejected$/", $json['body'])){
    $echo = $echo . "<p class=\"oauth-res\">アクセストークンが無効になっています。<a href=\"{$relogin}\">再認証</a>を行なってください。</p>";
    $json = getJson(constRequest($json_url_noaouth), FALSE);
}
if ($json['stat'] !== TRUE){
  $contents = strip_tags($json['stat']);
  $echo = $echo . "<p>はてなハイク API からデータを取得できなかったような気がします。</p>\n";
  $echo = $echo . "<blockquote>";
  if (isset($json['http'])) echo "HTTP {$json['http']}<br />";
  $echo = $echo . "{$json['stat']}<br />{$contents}</blockquote>\n";
  $timeline_putted = FALSE;
} else {
  $json_body = $json['body'];
  $contents = checkEntryData($json_body);
  if ($contents['stat'] == FALSE && $contents['ercode'] != 'x'){
/*  var_dump($contents);
  var_dump($json['body']);*/
	$echo = $echo . "<p>はてなハイク API からデータを取得できなかったような気がします。</p>\n";
	$echo = $echo . "<blockquote>HTTP {$json['http']}<br />";
	$echo = $echo . 'XML error '.$contents['ercode'].':'.$contents['ermes'];
	$echo = $echo . "<br />".strip_tags($json['body'])."</blockquote>\n";
	$timeline_putted = FALSE;
  } elseif ($contents['stat'] == FALSE && $contents['ercode'] == 'x'){
 	$echo = $echo . "<p>はてなハイク API からデータを取得できなかったような気がします。</p>\n";
	$echo = $echo . "<blockquote>HTTP {$json['http']}<br />{$contents['ermes']}</blockquote>\n";	
	$timeline_putted = FALSE;
  } else {
	$first_e = 'first';
	foreach ($contents['contents'] as $val){
	  echo mb_convert_encoding($echo, $charcode, 'UTF-8');
	  $echo = '';
	  if ($entries_mode == 'users' || $entries_mode == 'keyword_users' || $entries_mode == 'favours'){
		$echo = $echo . "<dl class=\"users-list\">\n";
		$entry_processor_mode = 'users';
		require 'entry_processor.php';
		$echo = $echo . "</dl>";
	  } else {
		$entry_processor_mode = "entries";
		require 'entry_processor.php';
		echo mb_convert_encoding($echo, $charcode, 'UTF-8');
		$echo = '';
	  }
	  $timeline_putted = TRUE;
	}
  }
}
echo mb_convert_encoding($echo, $charcode, 'UTF-8');
$echo = '';
?>
<?php
// var_dump($contents);
if (isset($_SESSION['auth']) && $_SESSION['auth'] === TRUE){
if ($entries_mode == 'keyword_timeline' || $entries_mode == 'keyword_users'){
  if (isset($timeline_putted) && $timeline_putted === TRUE){
	$object_key = $contents['contents']->status[0]->keyword;
	$object_title = $contents['contents']->status[0]->target->title;
  } else {
	if ($entries_mode == 'keyword_timeline'){
	  $object_key = $_GET['keyword'];
	  $object_title =$_GET['keyword'];
	}
	if ($entries_mode == 'keyword_users'){
	  $object_key = $_GET['users'];
	  $object_title = $_GET['users'];
	}
  }
//   var_dump($status_0);
  if (preg_match("/^{$http_url_regexp}$/u", $object_key)){
	if (preg_match("/&/u", $object_key)){
	  $echo = $echo . '<p>URL: <a href="'.$mobile_gateway.rawurlencode(rawurldecode($object_key)).'" class="external-link">'.htmlspecialchars($object_title,ENT_QUOTES).'</a> を<a href="mailto:b@hatena.ne.jp?body='.rawurlencode(rawurldecode($object_key)).'">メールではてなブックマークに追加する。</a></p>';
	} else {
	  $echo = $echo . '<form method="post" action="" enctype="application/x-www-form-urlencoded" accept-charset="'.$meta_charset.'" class="hateb-form">'."\n";
	  $echo = $echo .  '<label>URL: <a href="'.$mobile_gateway.rawurlencode(rawurldecode($object_key)).'" class="external-link">'.htmlspecialchars($object_title,ENT_QUOTES).'</a> をはてなブックマークに追加する。</label><br />';
	  $echo = $echo . '<label for="bcomment">コメント:</label>';
	  $echo = $echo . '<input type="text" id="bcomment" name="comment" maxlength="100" value="" title="ブックマークコメント" />';
	  $echo = $echo . '<input type="hidden" name="url" value="'.$get_keyword.'" />';
	  $echo = $echo . '<input type="hidden" name="posting" value="hateb" />';
	  $echo = $echo . '<input type="hidden" name="return" value="'.htmlspecialchars($self_anchor_possibly_with_pagenum, ENT_QUOTES).'" />';
	  $echo = $echo . '<input type="submit" id="post-hateb" value="[B!]" title="URL をはてなブックマークに追加する。" />';
	  $echo = $echo . '</form>';
  // 	echo "...";
	}
  } elseif (preg_match("/^(asin:)([[:alnum:]])+$/u", $object_key)){
	$asin = preg_replace("/^(asin:)([[:alnum:]]+)$/u", "\${2}", $object_key);
	$echo = $echo . '<p class="to-amazon"><a href="'.'http://www.amazon.co.jp/gp/aw/d.html/?a='.$asin.'" class="external-link">'.$object_title.' を Amazon.co.jp で見る。</a></p>';
  } elseif (preg_match("/^id:[a-zA-Z1234567890]{1}[-_a-zA-Z1234567890@]{1,30}[a-zA-Z1234567890]{1} *$/u", $object_key)){
  } else {
	  $echo = $echo . '<form method="post" action="" enctype="application/x-www-form-urlencoded" accept-charset="'.$meta_charset.'" class="hateb-form">'."\n";
	  $echo = $echo .  '<label>このハイクキーワードをはてなブックマークに追加する。</label><br />';
	  $echo = $echo . '<label for="bcomment">コメント:</label>';
	  $echo = $echo . '<input type="text" id="bcomment" name="comment" maxlength="100" value="" title="ブックマークコメント" />';
	  $echo = $echo . '<input type="hidden" name="url" value="http://'.$haiku_host.'/keyword/'.htmlspecialchars($get_keyword, ENT_QUOTES).'" />';
	  $echo = $echo . '<input type="hidden" name="posting" value="hateb" />';
	  $echo = $echo . '<input type="hidden" name="return" value="'.htmlspecialchars($self_anchor_possibly_with_pagenum, ENT_QUOTES).'" />';
	  $echo = $echo . '<input type="submit" id="post-hateb" value="[B!]" title="このハイクキーワードをはてなブックマークに追加する。" />';
	  $echo = $echo . '</form>';
  }
}
}
$echo = $echo . '</div>';
echo mb_convert_encoding($echo, $charcode, 'UTF-8');
$echo = '';
?>

<?php
$navi_paging = TRUE;
$navi_imaging = TRUE;
require 'footer_include.php';
$echo = $echo . '</div></body></html>';
echo mb_convert_encoding($echo, $charcode, 'UTF-8');
if (isset($_SESSION['oauth_stat'])) unset($_SESSION['oauth_stat']);
?>
